<?php
namespace Teknisa\CMP\Modules\V1\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class SearchProdutoDemanda extends \Teknisa\GER\Modules\V1\Controllers\TeknisaCrud {

    protected $dataSourceName = "search_produtodemanda";

    public function searchProdutoDemanda(Request\Filter $request, Response $response) {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $onDemandFilter = new FilterCriteria($this->dataSourceName);
            
            $onDemandFilter = self::montaCondicao($onDemandFilter,$conditions);
            $dataSource = $this->dataSourceManager->findBy($onDemandFilter);

            $dataSet = self::montaDataSet($dataSource->getRows());
            $response->addDataSet(new DataSet('/searchProdutoDemanda', $dataSet));
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }


    public function montaCondicao($onDemandFilter,$conditions){
        foreach($conditions as $condition){
            if($condition['columnName'] != 'CDARVPROD'){
                $onDemandFilter->addCondition($condition['columnName'],$condition['value']);
            }
        }

        if(end($conditions)['columnName'] === 'CDARVPROD'){
            $onDemandFilter->addCondition('CDPRODNIVANTE',end($conditions)['value']);
        } else{
            $onDemandFilter->addCondition('CDNVPRODUTO', '1');
        }

        $onDemandFilter->addOrderby('CDARVPROD');

        return $onDemandFilter;
    }


    public function montaDataSet(array $dataSource) {
        $dataSet = array();

        foreach($dataSource as $data){
            if($data['PAI'] == 'true'){
                $data['PAI'] = true;
            } else{
                $data['PAI'] = false;
            }

            array_push($dataSet, array(
                'CDARVPROD' => $data['CDARVPROD'],
                'CDPRODUTO' => $data['CDPRODUTO'],
                'NMPRODUTO' => $data['NMPRODUTO'],
                'SGUNIDADE' => $data['SGUNIDADE'],
                'CDNVPRODUTO' => $data['CDNVPRODUTO'],
                'CDPRODNIVANTE' => $data['CDPRODNIVANTE'],
                '_hasChild' => $data['PAI']
            ));
        }

        return $dataSet;
    }
}